#-*- coding: utf-8 -*-
#
# Système de gestion des adhésions de Nos oignons
# Copyright © 2013-2014 Nos oignons <contact@nos-oignons.net>
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as
# published by the Free Software Foundation, either version 3 of the
# License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
#
# You should have received a copy of the GNU Affero General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.

require 'fileutils'

Given /^un clone du Git contenant les adhésions$/ do
  # Create main repository
  @main_repository_path = expand_path('main')
  create_directory 'main'
  cd 'main'
  run_simple 'git init --quiet --bare'
  cd '..'

  # Clone it now
  run_simple "git clone --quiet --local file://#{expand_path('.')}/main clone"
  cd 'clone'
  create_directory 'Membres'
  BASE_MEMBERS.each_pair do |number, data|
    file = member_filename_for_id(number)
    File.write file, render_member_file(data)
    run_simple "git add #{file}"
  end
  run_simple 'git commit -m "Initial data set from fixtures"'
  run_simple 'git push --quiet origin master'
end

Given /^le « pre-commit hook » correctement configuré$/ do
  FileUtils.ln_s File.expand_path('../../../bin/pre-commit-hook', __FILE__),
                 "#{expand_path('.')}/.git/hooks/pre-commit"
end

Given /^le « pre-receive hook » configuré sur le dépôt principal$/ do
  FileUtils.ln_s File.expand_path('../../../bin/pre-receive-hook', __FILE__),
                 "#{@main_repository_path}/hooks/pre-receive"
end

When /je fais un `commit` du nouveau fichier$/ do
  run_simple "git add #{@file}"
  run_simple "git commit #{@file} -m 'new file'", false # do not fail on error
end

When /je pousse la modification$/ do
  run_simple "git add #{@file}"
  run_simple "git commit #{@file} -m 'new file'"
  run_simple 'git push origin master', false # do not fail on error
end
